Attribute VB_Name = "ShellExtension_bas"
Option Explicit
' The Sub BrowseTo in this module will allow you to add hyperlinks to urls to your
' program.   It will load the default browser for browser based URL's such as
' HTTP, FTP and it will load the default mail client for Mail based URL's like
' MAILTO

#If Win32 Then
Private Declare Function ShellExecute Lib "Shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
'Private Declare Function GetDesktopWindow Lib "user32" () As Long
#Else
Private Declare Function ShellExecute Lib "shell.dll" (ByVal hwnd As Integer, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Integer) As Integer
'Private Declare Function GetDesktopWindow Lib "User" () As Integer
#End If

Private Const SW_NORMAL = 1
Private Const SW_MINIMIZE = 6
Private Const SW_MAXIMIZE = 3

Public Function BrowseTo(ByVal sURL As String, apphwnd As Long) As Boolean
   #If Win32 Then
     Dim xRet      As Long
   #Else
     Dim xRet      As Integer
   #End If
   
   ' GetDesktopWindow() is used, because the function requires a valid Hwnd, and to make
   ' this sub portable I didn't want to use a forms, Hwnd.   The Hwnd will be the
   ' parent of any Msgbox or whatever the program might bring up before opening any windows.
   'xRet = ShellExecute(GetDesktopWindow(), vbNullString, sURL, vbNullString, App.Path, SW_NORMAL)
   xRet = ShellExecute(apphwnd, vbNullString, sURL, vbNullString, App.Path, SW_NORMAL)
     
   ' Xret will be > 32 on success and funciton will return true
   ' or <=32 on failure and function will return false
   If xRet > 32 Then BrowseTo = True Else BrowseTo = False
End Function


