Attribute VB_Name = "hangup_bas"
Option Explicit

Private Const ERROR_SUCCESS = 0&
Private Const RAS_MaxEntryName As Integer = 256
Private Const RAS_MaxDeviceType As Integer = 16
Private Const RAS_MaxDeviceName As Integer = 128
Private Const RAS_RASCONNSIZE As Integer = 412

Private Type RasEntryName
   dwSize As Long
   szEntryName(RAS_MaxEntryName) As Byte
End Type

Private Type RASCONN
   dwSize As Long
   hrasconn As Long
   szEntryName(RAS_MaxEntryName) As Byte
   szDeviceType(RAS_MaxDeviceType) As Byte
   szDeviceName(RAS_MaxDeviceName) As Byte
End Type

Private Declare Function RasEnumConnections Lib "rasapi32.dll" Alias "RasEnumConnectionsA" (lprasconn As Any, lpcb As Long, lpcConnections As Long) As Long
Private Declare Function RasHangUp Lib "rasapi32.dll" Alias "RasHangUpA" (ByVal hrasconn As Long) As Long

Public Function DisconnectRas() As Boolean
   Dim i As Long
   Dim lprasconn(255) As RASCONN
   Dim lpcb As Long
   Dim lpcConnections As Long
   Dim hrasconn As Long
   Dim bOk As Boolean
   
   bOk = False
   lprasconn(0).dwSize = RAS_RASCONNSIZE
   lpcb = RAS_MaxEntryName * lprasconn(0).dwSize
   lpcConnections = 0
   
   If RasEnumConnections(lprasconn(0), lpcb, lpcConnections) = ERROR_SUCCESS Then
      For i = 0 To lpcConnections - 1
         hrasconn = lprasconn(i).hrasconn
         If RasHangUp(ByVal hrasconn) = 0 Then
            bOk = True
            Call Sleep(3000)
         Else
            bOk = False
            Exit For
         End If
      Next i
   End If
   DisconnectRas = bOk
End Function

