Attribute VB_Name = "kalive_bas"
Option Explicit
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Copyright 1996-2000 VBnet, Randy Birch, All Rights Reserved.
' Some pages may also contain other copyrights by the author.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' You are free to use this code within your own applications,
' but you are expressly forbidden from selling or otherwise
' distributing this source code without prior written consent.
' This includes both posting free demo projects made from this
' code as well as reproducing the code in text or html format.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Private Const IP_SUCCESS As Long = 0
Private Const MAX_WSADescription As Long = 256
Private Const MAX_WSASYSStatus As Long = 128
Private Const WS_VERSION_REQD As Long = &H101
'Private Const WS_VERSION_MAJOR As Long = WS_VERSION_REQD \ &H100 And &HFF&
'Private Const WS_VERSION_MINOR As Long = WS_VERSION_REQD And &HFF&
'Private Const MIN_SOCKETS_REQD As Long = 1
'Private Const SOCKET_ERROR As Long = -1

Private Type WSADATA
   wVersion As Integer
   wHighVersion As Integer
   szDescription(0 To MAX_WSADescription) As Byte
   szSystemStatus(0 To MAX_WSASYSStatus) As Byte
   wMaxSockets As Long
   wMaxUDPDG As Long
   dwVendorInfo As Long
End Type

Private Declare Function gethostbyname Lib "WSOCK32.DLL" _
  (ByVal hostname As String) As Long
  
'Private Declare Sub CopyMemory Lib "kernel32" _
'   Alias "RtlMoveMemory" _
'  (xDest As Any, _
'   xSource As Any, _
'   ByVal nbytes As Long)

'Private Declare Function lstrlenA Lib "kernel32" _
'  (lpString As Any) As Long

Private Declare Function WSAStartup Lib "WSOCK32.DLL" _
   (ByVal wVersionRequired As Long, _
    lpWSADATA As WSADATA) As Long
    
Private Declare Function WSACleanup Lib "WSOCK32.DLL" () As Long

Public Function KeepAlive() As Boolean
   'Dim sHostName As String
   
   If SocketsInitialize() Then
      KeepAlive = True
     'pass the host address to the function
      'sHostName = "www.microsoft.com"
      'Text2.Text = GetIPFromHostName(sHostName)
      'Call GetIPFromHostName(sHostName)
      Call GetIPFromHostName(DNSTryOut)
      Call SocketsCleanup
   Else
      'error
      KeepAlive = False
   End If
End Function

Private Function SocketsInitialize() As Boolean
   Dim WSAD As WSADATA
   
   SocketsInitialize = IIf(WSAStartup(WS_VERSION_REQD, WSAD) = IP_SUCCESS, True, False) 'if IP_SUCCESS NO ERROR
End Function

Private Function SocketsCleanup() As Boolean
   SocketsCleanup = IIf(WSACleanup() = 0, True, False) ' if 0 no error
End Function

'Public Function GetIPFromHostName(ByVal sHostName As String) As String
Private Function GetIPFromHostName(ByVal sHostName As String) As Boolean

  'converts a host name to an IP address.
   GetIPFromHostName = IIf(gethostbyname(sHostName & vbNullChar) = 0, False, True) 'if 0 error

   'Dim nbytes As Long
   'Dim ptrHosent As Long
   'Dim ptrName As Long
   'Dim ptrAddress As Long
   'Dim ptrIPAddress As Long
   'Dim sAddress As String
   
   'sAddress = Space$(4)

   'ptrHosent = gethostbyname(sHostName & vbNullChar)

   'If ptrHosent <> 0 Then

     'assign pointer addresses and offset
     
     'The Address is offset 12 bytes from the start of
     'the HOSENT structure. Note: Here we are retrieving
     'only the first address returned. To return more than
     'one, define sAddress as a string array and loop through
     'the 4-byte ptrIPAddress members returned. The last
     'item is a terminating null. All addresses are returned
     'in network byte order.
      'ptrAddress = ptrHosent + 12
      
     'get the IP address
      'CopyMemory ptrAddress, ByVal ptrAddress, 4
      'CopyMemory ptrIPAddress, ByVal ptrAddress, 4
      'CopyMemory ByVal sAddress, ByVal ptrIPAddress, 4

      'GetIPFromHostName = IPToText(sAddress)

   'End If
   
End Function

'Private Function IPToText(ByVal IPAddress As String) As String
'
'   IPToText = CStr(Asc(IPAddress)) & "." & _
'              CStr(Asc(Mid$(IPAddress, 2, 1))) & "." & _
'              CStr(Asc(Mid$(IPAddress, 3, 1))) & "." & _
'              CStr(Asc(Mid$(IPAddress, 4, 1)))
'
'End Function
