Attribute VB_Name = "netdetect_bas"
Option Explicit

'old methode
Private Declare Function InternetGetConnectedState _
   Lib "wininet.dll" (ByRef lpdwFlags As Long, _
   ByVal dwReserved As Long) As Long
'Local system uses a modem to connect to
'     the Internet.
Private Const INTERNET_CONNECTION_MODEM As Long = &H1
'Local system uses a LAN to connect to t
'     he Internet.
Private Const INTERNET_CONNECTION_LAN As Long = &H2
'Local system uses a proxy server to con
'     nect to the Internet.
Private Const INTERNET_CONNECTION_PROXY As Long = &H4
'No longer used.
Private Const INTERNET_CONNECTION_MODEM_BUSY As Long = &H8
Private Const INTERNET_RAS_INSTALLED As Long = &H10
Private Const INTERNET_CONNECTION_OFFLINE As Long = &H20
Private Const INTERNET_CONNECTION_CONFIGURED As Long = &H40
'InternetGetConnectedState wrapper funct
'     ions

'new methode
Private Const ERROR_SUCCESS = 0&
Private Const ApINULL = 0&
Private Const HKEY_LOCAL_MACHINE = &H80000002
Private ReturnCode As Long

Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal _
hKey As Long) As Long

Private Declare Function RegOpenKey Lib "advapi32.dll" Alias _
"RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As _
String, phkResult As Long) As Long

Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias _
"RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName _
As String, ByVal lpReserved As Long, lpType As Long, _
lpData As Any, lpcbData As Long) As Long

Private Function IsNetConnectViaModem() As Boolean
    Dim dwFlags As Long
    'pass an empty varialbe into which the A
    '     PI will
    'return the flags associated with the co
    '     nnection
    Call InternetGetConnectedState(dwFlags, 0&)
    'return True if the flags indicate a mod
    '     em connection
    IsNetConnectViaModem = dwFlags And INTERNET_CONNECTION_MODEM
End Function

Private Function IsNetConnectOnline() As Boolean
    'no flags needed here - the API returns
    '     True
    'if there is a connection of any type
    IsNetConnectOnline = InternetGetConnectedState(0&, 0&)
End Function

Private Function ActiveConnection() As Boolean
   Dim hKey As Long
   Dim lpSubKey As String
   Dim phkResult As Long
   Dim lpValueName As String
   Dim lpReserved As Long
   Dim lpType As Long
   Dim lpData As Long
   Dim lpcbData As Long
   ActiveConnection = False
   lpSubKey = "System\CurrentControlSet\Services\RemoteAccess"
   ReturnCode = RegOpenKey(HKEY_LOCAL_MACHINE, lpSubKey, _
   phkResult)
   
   If ReturnCode = ERROR_SUCCESS Then
       hKey = phkResult
       lpValueName = "Remote Connection"
       lpReserved = ApINULL
       lpType = ApINULL
       lpData = ApINULL
       lpcbData = ApINULL
       ReturnCode = RegQueryValueEx(hKey, lpValueName, _
       lpReserved, lpType, ByVal lpData, lpcbData)
       lpcbData = Len(lpData)
       ReturnCode = RegQueryValueEx(hKey, lpValueName, _
       lpReserved, lpType, lpData, lpcbData)
       
       If ReturnCode = ERROR_SUCCESS Then
           If lpData = 0 Then
               ActiveConnection = False
           Else
               ActiveConnection = True
           End If
       End If
   RegCloseKey (hKey)
   End If
End Function

Public Function IsConnected2net() As Boolean
   IsConnected2net = False
   Select Case currentNetDetection
      Case RAS_NETDETECTION
         If RasConnection Then
            IsConnected2net = True
         End If
      Case DLL_NETDETECTION
         If IsNetConnectViaModem() And IsNetConnectOnline() Then
            IsConnected2net = True
         End If
      Case REG_NETDETECTION
         If ActiveConnection Then
            IsConnected2net = True
         End If
   End Select
End Function

