Attribute VB_Name = "modHideWin_bas"
Option Explicit

Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
       Private Const conHwndTopmost = -1
       Private Const conSwpShowWindow = &H40
       Private Const HWND_NOTOPMOST = -2

       Private Const SWP_NOSIZE = &H1
       Private Const SWP_DRAWFRAME = &H20
       Private Const SWP_HIDEWINDOW = &H80
       
Private Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Private Const WM_CLOSE = &H10

Private Declare Function TerminateProcess Lib "kernel32" (ByVal hProcess As Long, ByVal uExitCode As Long) As Long
   
Private Declare Function OpenProcess Lib "kernel32" _
    (ByVal dwDesiredAccess As Long, _
     ByVal bInheritHandle As Long, _
     ByVal dwProcessId As Long) As Long

Private Declare Function CloseHandle Lib "kernel32" _
    (ByVal hObject As Long) As Long

Private Const PROCESS_QUERY_INFORMATION = &H400
Private Const PROCESS_TERMINATE = &H1

Private Const STATUS_PENDING = &H103&
   
Public Sub OntopWindow(hwnd As Long)
   Dim retcode As Long
   On Error GoTo ReportIt
   ' set this window ontop
   retcode = SetWindowPos(hwnd, conHwndTopmost, 0, 0, 0, 0, SWP_NOSIZE)
   On Error GoTo 0
   Exit Sub
   
ReportIt:
   Err.Clear
   On Error GoTo 0
End Sub
   
Public Sub BruteForceCloseProcess(processId As Long)
   Dim uExitCode As Long, hProcess As Long
   
   hProcess = OpenProcess(PROCESS_QUERY_INFORMATION + PROCESS_TERMINATE, False, processId)
   If hProcess <> 0 Then
      Call TerminateProcess(hProcess, uExitCode)
      Call CloseHandle(hProcess)
   End If
End Sub
   
' close the specified window by it's handle
Public Sub CloseWindow(hwnd&)
     Dim RetVal As Long
          
     If hwnd <> 0 Then
        RetVal = PostMessage(hwnd, WM_CLOSE, 0&, 0&)
        'If RetVal = 0 Then
        '  MsgBox "Error_Closing," & "Error closing " & sTitle & "."
        'End If
     'Else
         'MsgBox "Not_Open," & sTitle & " is not open."
     End If
End Sub

Public Sub cleanreg()
   Dim svalue As String

   If fEnumKey("HKLM", "Software\NetZero, Inc.\NetZero", svalue) = 0 Then
      If Len(svalue) > 0 Then
         Call fDeleteValue("HKLM", "Software\NetZero, Inc.\NetZero", "MachineID")
         Call fDeleteValue("HKLM", "Software\NetZero, Inc.\NetZero", "SessionCtr")
      
         Call recCleanreg("HKLM", "Software\NetZero, Inc.\NetZero", "USERS")
      End If
   End If
End Sub

Private Sub recCleanreg(topkey As String, midkey As String, thekey As String)
   Dim svalue As String
   Dim i As Long, lastvbnullchar As Long

   If fEnumKey(topkey, midkey + "\" + thekey, svalue) = 0 Then
      If Len(svalue) > 0 Then
         lastvbnullchar = 0
         For i = 1 To Len(svalue)
            If Mid$(svalue, i, 1) = vbNullChar Then
               If (i - lastvbnullchar) > 1 Then
                  Call recCleanreg(topkey, midkey + "\" + thekey, Mid$(svalue, lastvbnullchar + 1, i - lastvbnullchar - 1))
               End If
               lastvbnullchar = i
            End If
         Next i
         Call fDeleteKey(topkey, midkey, thekey)
      End If
   End If
End Sub
