Attribute VB_Name = "getshortname_bas"
Option Explicit

Private Declare Function GetShortPathName Lib "kernel32" _
   Alias "GetShortPathNameA" (ByVal lpszLongPath As String, _
   ByVal lpszShortPath As String, ByVal cchBuffer As Long) As Long

Public Function GetShortName(ByVal sLongFileName As String, converted As String) As Boolean
   Dim lRetVal As Long, sShortPathName As String, iLen As Integer
   'Set up buffer area for API function call return
   sShortPathName = Space(255)
   iLen = Len(sShortPathName)
   converted = ""
   
   'Call the function
   lRetVal = GetShortPathName(sLongFileName, sShortPathName, iLen)
   'Strip away unwanted characters.
   If lRetVal = 0 Then
      GetShortName = False
   Else
      converted = Left(sShortPathName, lRetVal)
      GetShortName = True
   End If
End Function
